package cl.axg.hls_player;

import android.app.Activity;
import android.content.res.Configuration;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.google.android.exoplayer2.ExoPlaybackException;
import com.google.android.exoplayer2.Player;
import com.google.android.exoplayer2.SimpleExoPlayer;
import com.google.android.exoplayer2.source.MediaSource;
import com.google.android.exoplayer2.ui.PlayerView;
import com.google.android.exoplayer2.upstream.DefaultHttpDataSource;
import com.google.android.exoplayer2.upstream.DefaultHttpDataSourceFactory;
import com.google.android.exoplayer2.util.Util;


public class MainActivity extends Activity {

    private static final String TAG = "requestdebug";
    private String URL_VIDEO= null;
    PlayerView playerView;
    SimpleExoPlayer player;
    Runnable mRunnable;
    boolean hayError;
    Handler mHandler = new Handler();
    Common common = new Common();

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        super.onWindowFocusChanged(hasFocus);
        if (hasFocus) {
            common.habilitarPreferenciasReproductor(getWindow());
        }
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        common.habilitarVentanaEncendida(getWindow());
        Bundle extras = getIntent().getExtras();
        if (extras != null){
            URL_VIDEO  =(String) extras.get("url");
            URL_VIDEO  =(String) extras.get("url");
        }else{
            Log.d(TAG, "Sin URL video exoplayer");
            throw new IllegalArgumentException("Sin URL video exoplayer");

        }

        setContentView(R.layout.activity_main);
        common.ignoreSSL();
        initializePlayer();
    }


    private void initializePlayer() {
        playerView = this.findViewById(R.id.playerView);
        player = common.initPlayer(this, playerView);
        ImageView playPauseVideo =  findViewById(R.id.playPauseVideo);
        playPauseVideo.setImageResource(  R.drawable.exo_icon_pause);
        playerView.getVideoSurfaceView().setOnClickListener(view -> {
            if (playerView.isControllerVisible()) {
                // Do something if controls are visible
                playerView.hideController();


                Log.e("TOUCH", "hideController!");



            } else {
                // Do something else if controls are not showing
                playerView.showController();

                View someView = findViewById(R.id.viewControl);
                someView.setBackgroundResource( R.drawable.exoplayer_bottom);

                Log.e("TOUCH", "showController!");
            }
        });
        player.addListener(new Player.EventListener() {
            @Override
            public void onPlayerError(ExoPlaybackException error) {
                mHandler.postDelayed(() -> {
                    hayError=true;
                    pause();
                    reproducir();
                }, 1000 * 10);
            }

            @Override
            public void onPlayerStateChanged(boolean playWhenReady, int playbackState) {
                if(playbackState==Player.STATE_ENDED){
                    reproducir();
                }
            }
        });

        player.setPlayWhenReady(true);
        play(player);
    }

    public void pause(){
        player.setPlayWhenReady(false);
        hayError = false;
    }


    public void play(SimpleExoPlayer player){

        prepareMediaForPlaying(Uri.parse(URL_VIDEO));
        player.setPlayWhenReady(true);
        hayError = false;
    }

    public void reproducir(){

        prepareMediaForPlaying(Uri.parse(URL_VIDEO));
        player.setPlayWhenReady(true);
        hayError = false;
    }
    private void prepareMediaForPlaying(Uri mediaSourceUri) {
        player.prepare(common.getMediaSource(mediaSourceUri, this));
        player.setPlayWhenReady(true);

    }


    public void rewindVideoClick(View arg0)
    {
        player.seekTo(player.getCurrentPosition() - 10000);
    }

    public void playPauseVideoClick(View arg0)
    {
        ImageView playPauseVideo =  findViewById(R.id.playPauseVideo);
        playPauseVideo.setImageResource(player.isPlaying() ? R.drawable.exo_icon_play :  R.drawable.exo_icon_pause);

        player.setPlayWhenReady(!player.isPlaying());
    }

    public void forwardVideoClick(View arg0)
    {
        player.seekTo(player.getCurrentPosition() + 10000);
    }



    public void closeImgBtnOnClick(View v)
    {
        this.finish();
    }

    private void releasePlayer() {
        if (player != null) {
            player.release();
            player = null;
        }
    }
    private void pausePlayer() {
        if (player != null) {
            player.setPlayWhenReady(false);
            player.getPlaybackState();
        }
    }
    private void resumePlayer() {
        if (player != null) {
            player.setPlayWhenReady(true);
            player.getPlaybackState();
        }
    }
    @Override
    protected void onPause() {
        super.onPause();
        pausePlayer();
        if (mRunnable != null) {
            mHandler.removeCallbacks(mRunnable);
        }
    }
    @Override
    protected void onRestart() {
        super.onRestart();
        resumePlayer();
    }
    @Override
    protected void onDestroy() {
        super.onDestroy();
        releasePlayer();
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        // ignore orientation/keyboard change
        super.onConfigurationChanged(newConfig);
    }

    @Override
    public void onBackPressed() {
        Log.d("CDA", "onBackPressed Called");
        super.onBackPressed();
    }

}